#ifndef _H_382EBD256D4E3150AEA19D4707FF82D2_AckermannDrive_DCPS_H_
#define _H_382EBD256D4E3150AEA19D4707FF82D2_AckermannDrive_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AckermannDrive_.h"


namespace ackermann_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AckermannDrive_TypeSupportInterface;

            typedef AckermannDrive_TypeSupportInterface * AckermannDrive_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AckermannDrive_TypeSupportInterface> AckermannDrive_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AckermannDrive_TypeSupportInterface> AckermannDrive_TypeSupportInterface_out;


            class AckermannDrive_DataWriter;

            typedef AckermannDrive_DataWriter * AckermannDrive_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AckermannDrive_DataWriter> AckermannDrive_DataWriter_var;
            typedef DDS_DCPSInterface_out < AckermannDrive_DataWriter> AckermannDrive_DataWriter_out;


            class AckermannDrive_DataReader;

            typedef AckermannDrive_DataReader * AckermannDrive_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AckermannDrive_DataReader> AckermannDrive_DataReader_var;
            typedef DDS_DCPSInterface_out < AckermannDrive_DataReader> AckermannDrive_DataReader_out;


            class AckermannDrive_DataReaderView;

            typedef AckermannDrive_DataReaderView * AckermannDrive_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AckermannDrive_DataReaderView> AckermannDrive_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AckermannDrive_DataReaderView> AckermannDrive_DataReaderView_out;

            struct AckermannDrive_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < AckermannDrive_, struct AckermannDrive_Seq_uniq_> AckermannDrive_Seq;
            typedef DDS_DCPSSequence_var < AckermannDrive_Seq> AckermannDrive_Seq_var;
            typedef DDS_DCPSSequence_out < AckermannDrive_Seq> AckermannDrive_Seq_out;

            class  AckermannDrive_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AckermannDrive_TypeSupportInterface_ptr _ptr_type;
                typedef AckermannDrive_TypeSupportInterface_var _var_type;

                static AckermannDrive_TypeSupportInterface_ptr _duplicate (AckermannDrive_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AckermannDrive_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AckermannDrive_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AckermannDrive_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AckermannDrive_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AckermannDrive_TypeSupportInterface () {};
                ~AckermannDrive_TypeSupportInterface () {};
            private:
                AckermannDrive_TypeSupportInterface (const AckermannDrive_TypeSupportInterface &);
                AckermannDrive_TypeSupportInterface & operator = (const AckermannDrive_TypeSupportInterface &);
            };

            class  AckermannDrive_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AckermannDrive_DataWriter_ptr _ptr_type;
                typedef AckermannDrive_DataWriter_var _var_type;

                static AckermannDrive_DataWriter_ptr _duplicate (AckermannDrive_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AckermannDrive_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AckermannDrive_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AckermannDrive_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AckermannDrive_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AckermannDrive_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AckermannDrive_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AckermannDrive_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AckermannDrive_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AckermannDrive_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AckermannDrive_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AckermannDrive_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AckermannDrive_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AckermannDrive_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AckermannDrive_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AckermannDrive_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AckermannDrive_& instance_data) = 0;

            protected:
                AckermannDrive_DataWriter () {};
                ~AckermannDrive_DataWriter () {};
            private:
                AckermannDrive_DataWriter (const AckermannDrive_DataWriter &);
                AckermannDrive_DataWriter & operator = (const AckermannDrive_DataWriter &);
            };

            class  AckermannDrive_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AckermannDrive_DataReader_ptr _ptr_type;
                typedef AckermannDrive_DataReader_var _var_type;

                static AckermannDrive_DataReader_ptr _duplicate (AckermannDrive_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AckermannDrive_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AckermannDrive_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AckermannDrive_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AckermannDrive_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AckermannDrive_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AckermannDrive_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AckermannDrive_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AckermannDrive_& instance) = 0;

            protected:
                AckermannDrive_DataReader () {};
                ~AckermannDrive_DataReader () {};
            private:
                AckermannDrive_DataReader (const AckermannDrive_DataReader &);
                AckermannDrive_DataReader & operator = (const AckermannDrive_DataReader &);
            };

            class  AckermannDrive_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AckermannDrive_DataReaderView_ptr _ptr_type;
                typedef AckermannDrive_DataReaderView_var _var_type;

                static AckermannDrive_DataReaderView_ptr _duplicate (AckermannDrive_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AckermannDrive_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AckermannDrive_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AckermannDrive_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AckermannDrive_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AckermannDrive_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AckermannDrive_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AckermannDrive_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AckermannDrive_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AckermannDrive_& instance) = 0;

            protected:
                AckermannDrive_DataReaderView () {};
                ~AckermannDrive_DataReaderView () {};
            private:
                AckermannDrive_DataReaderView (const AckermannDrive_DataReaderView &);
                AckermannDrive_DataReaderView & operator = (const AckermannDrive_DataReaderView &);
            };
        }

    }

}

#endif
